From 7ada38c554dceda2d495601445b82229948264ce Mon Sep 17 00:00:00 2001
From: Frederic Cambus <fred@statdns.com>
Date: Thu, 10 Mar 2016 20:00:38 +0100
Subject: [PATCH] Add support for using pledge() on OpenBSD

---
 configure.ac | 4 ++--
 jo.c         | 7 +++++++
 2 files changed, 9 insertions(+), 2 deletions(-)

diff --git a/configure.ac b/configure.ac
index 07aa9f8..e078ba8 100644
--- a/configure.ac
+++ b/configure.ac
@@ -8,13 +8,13 @@ AC_PROG_CC
 
 # Checks for header files.
 AC_USE_SYSTEM_EXTENSIONS
-AC_CHECK_HEADERS([stddef.h stdint.h stdlib.h string.h])
+AC_CHECK_HEADERS([stddef.h stdint.h stdlib.h string.h unistd.h])
 
 # Checks for library functions.
 AC_FUNC_MALLOC
 AC_FUNC_REALLOC
 AC_FUNC_STRTOD
-AC_CHECK_FUNCS([strchr strrchr strlcpy strlcat snprintf])
+AC_CHECK_FUNCS([strchr strrchr strlcpy strlcat snprintf pledge])
 
 AM_INIT_AUTOMAKE([foreign -Wall])
 AM_SILENT_RULES([yes])
diff --git a/jo.c b/jo.c
index 819baf0..f16f960 100644
--- a/jo.c
+++ b/jo.c
@@ -5,6 +5,7 @@
 #include <string.h>
 #include <getopt.h>
 #include <ctype.h>
+#include <err.h>
 #include "json.h"
 
 /*
@@ -363,6 +364,12 @@ int main(int argc, char **argv)
 	int flags = 0;
 	JsonNode *json, *op;
 
+#if HAVE_PLEDGE
+	if (pledge("stdio", NULL) == -1) {
+		err(1, "pledge");
+	}
+#endif
+
 	progname = (progname = strrchr(*argv, '/')) ? progname + 1 : *argv;
 
 	while ((c = getopt(argc, argv, "aBpvV")) != EOF) {
